#ifndef __DX9_DX9TEXTURE_H__
#define __DX9_DX9TEXTURE_H__

#include "../oxcp.h"
#include "../texture.h"
#include <d3d9.h>

class DX9Texture : public Texture {
	OX::cp<IDirect3DTexture9> tex;

public:
	DX9Texture() {}
	virtual ~DX9Texture() {}

	// \[X擾
	virtual const void *getResource() const { return tex.getPtr(); }

	// eNX`쐬
	void create(IDirect3DDevice9 *dev, const Desc &desc, void *buffer) {
		D3DFORMAT format = (desc.format == Texture::RGBA8888) ? D3DFMT_A8R8G8B8 : D3DFMT_R8G8B8;
		if (FAILED(dev->CreateTexture(desc.width, desc.height, 0, 0, format, D3DPOOL_MANAGED, tex.toCreator(), 0)))
			return;
		D3DLOCKED_RECT r;
		if (FAILED(tex->LockRect(0, &r, 0, 0)))
			return;
		memcpy(r.pBits, buffer, desc.bufferSize);
		tex->UnlockRect(0);
	}
};

#endif
