#ifndef __TEXTUREINSTANCE_H__
#define __TEXTUREINSTANCE_H__

#include "texture.h"
#include "oxsp.h"

class TextureInstance {
public:
	enum Filter {
		Nearest
	};
	enum Operate {
		Decal,
		Modulate,
	};

	struct Desc {
		OX::sp<Texture> texture;
		Filter minFilter, magFilter;
		Operate op;
		Desc() : minFilter(Nearest), magFilter(Nearest), op(Decal) {}
	};

protected:
	Desc desc;

public:
	TextureInstance() {}
	~TextureInstance() {}

	// p[^擾
	const Desc &getDesc() const { return desc; }
	Desc &getDesc() { return desc; }

	// eNX`ݒ
	void setTexture(OX::sp<Texture> texture) {
		desc.texture = texture;
	}
};

#endif
